#pragma once

#include "aum1_cm1.h"

struct InterruptLock {
    bool was_locked;

    InterruptLock() : was_locked(__get_PRIMASK() != 0) { __disable_irq(); }

    ~InterruptLock() {
        if (!was_locked) {
            __enable_irq();
        }
    }
};
